# -*- coding: utf-8 -*-
import xbmcaddon,xbmcplugin,xbmcgui,sys,urllib,re,socket,os,json
import urllib2

socket.setdefaulttimeout(30)
pluginhandle = int(sys.argv[1])

addon = xbmcaddon.Addon(id='plugin.audio.Sport1.fm')
home = addon.getAddonInfo('path').decode('utf-8')
imageDir = os.path.join(home, 'thumbnails') + '/'
fanart=imageDir+"fanart.jpg"
thumb=imageDir+"images.jpg"





def main():
      streamurl='http://stream.sport1.fm/api/livestream-redirect/'
      gg = urllib2.urlopen('http://www.sport1.fm/data/live.json')
      json_data=json.load(gg)
      streams=json_data['feed']
      for stream in streams:
        streamid=(stream['resource']).encode('utf-8')
        name=(stream['title']).encode('utf-8')
        try:
          minute=(stream['game.minute'])
          minute=str(minute)
        except:
          minute=''
        try:
          gamescore=(stream['game.scores.current'])
          gamescore=(gamescore).encode('utf-8')
        except:
          gamescore=''
        if 'Einzel' in streamid:
          title=minute+' '+'Minute'+'  '+'Stand'+'  '+gamescore+'   '+name
        else:
          title=name
        url=streamurl+streamid+'.mp3'
        addLink(title,url,"Videolink",thumb)

def Videolink(url):
       starturl=url
       req = urllib2.Request(starturl)
       res = urllib2.urlopen(req)
       url = res.geturl()
       listitem = xbmcgui.ListItem(path=url)
       return xbmcplugin.setResolvedUrl(pluginhandle, True, listitem)

def addLink(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
        liz.setInfo( type="Music", infoLabels={ "Title": name } )
        liz.setProperty('IsPlayable', 'true')
        liz.setProperty('fanart_image', fanart)
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz)
        return ok

def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

params=parameters_string_to_dict(sys.argv[2])
mode=params.get('mode')
url=params.get('url')
if type(url)==type(str()):
  url=urllib.unquote_plus(url)
if mode == 'Videolink':
    Videolink(url)
main()

xbmcplugin.endOfDirectory(pluginhandle)

